-- Flame
-- Mobj Functions

rawset(_G, "KOTH_getPlayersInRadius", function(mo, range)
	if not (maptol & TOL_KOTH) then return end -- Nice try silly...
	if not mo or not mo.valid then return end

	if not range then range = 1024*FRACUNIT end -- Default range
	for player in players.iterate
		if (player.playerstate ~= PST_LIVE) then continue end -- Skip anyone not alive
		if not player.mo then continue end -- Not a valid mo object
		
		-- Calculate distance
		local dist = abs(P_AproxDistance(P_AproxDistance(mo.x - player.mo.x, mo.y - player.mo.y), mo.z - player.mo.z))
		
		if (dist < range) and (player.mo.z >= mo.z) then -- In range!
			player.mo.onkothhill = true
		else -- Out of range
			player.mo.onkothhill = false
		end
	end
end)

addHook("MobjThinker", function(mo)
	if not mo or not mo.valid then return end
	if (maptol & TOL_KOTH) then KOTH_getPlayersInRadius(mo, tonumber(mapheaderinfo[gamemap].flagrange)*FRACUNIT) end
end, MT_KOTHFLAG)