-- Flame
-- Player functions

addHook("MobjDamage", function(t, inf, src, dmg, dmgtype)
	if not (maptol & TOL_KOTH) then return false end
	if not t or not t.valid then return false end
	if not t.player or not t.player.valid then return false end
	if not t.onkothhill then return false end -- Not on the hill? Process normal behavior.
	
	local p = t.player
	if not p.rings then return end -- Process normal behavior.
	if p.powers[pw_flashing] then return false end -- Process normal behavior.
	--P_DoPlayerPain(p, src, inf)
	p.powers[pw_flashing] = 3*TICRATE
	t.z = $ + 1
	P_SetObjectMomZ(t, 12*FRACUNIT, false)
	t.state = t.info.painstate
	local thrustangle = R_PointToAngle2(inf.x - inf.momx, inf.y - inf.momy, t.x - t.momx, t.y - t.momy)
	P_InstaThrust(t, thrustangle, 40*FRACUNIT)
	t.lasthitter = src
	S_StartSound(t, sfx_s3kb9)
	P_PlayerRingBurst(p)
	P_PlayerWeaponPanelBurst(p)
	P_PlayerWeaponAmmoBurst(p)
	P_PlayerEmeraldBurst(p)
	p.rings = 0
	return true -- Override default behavior
end, MT_PLAYER)

addHook("PlayerSpawn", function(p)
	if not p or not p.valid then return end -- Something has gone horribly wrong.
	if not p.mo or not p.mo.valid then return end
	
	-- Initialize variables
	p.mo.lasthitter = nil
	p.mo.onkothhill = false
end)

rawset(_G, "KOTH_spawnRecoilSmoke", function(mo)
	if not mo or not mo.valid then return end
	
	if not (leveltime%4) then
		local trail = P_SpawnMobj(mo.x,
									mo.y,
									mo.z + mo.height/2, 
									MT_DUMMY)
		trail.state = S_TNTDUST_2
		trail.colorized = true
		trail.color = mo.lasthitter.color or SKINCOLOR_GREY
		trail.angle = R_PointToAngle2(trail.x, trail.y, mo.x + mo.momx, mo.y + mo.momy) -- Always point to your target
		trail.rollangle = P_RandomKey(36)*ANG10
		trail.destscale = 2*FRACUNIT
		trail.scalespeed = FRACUNIT/(TICRATE/2)
		
		trail.flags = $|MF_NOGRAVITY
		if (mo.eflags & MFE_VERTICALFLIP) then trail.flags = $|MFE_VERTICALFLIP end
		P_InstaThrust(trail, P_RandomKey(36)*ANG10, FRACUNIT)
		P_SetObjectMomZ(trail, FRACUNIT, false)
	end
end)

addHook("PlayerThink", function(p)
	if not (maptol & TOL_KOTH) then return end
	if not p or not p.valid then return end -- Something has gone horribly wrong.
	if not p.mo or not p.mo.valid then return end
	local mo = p.mo -- Simplify
	
	if not p.powers[pw_flashing] then -- Not flashing anymore
		p.mo.lasthitter = nil -- No more last hit.
	end
	
	-- Did you just get hit? Spawn some smoke of the enemies' color
	if p.mo.lasthitter and p.mo.lasthitter.valid
	and (mo.state == mo.info.painstate)
		KOTH_spawnRecoilSmoke(p.mo)
	end
	
	-- Spawn sparkles, indicating different knockback parameters
	-- Award score too, why not?
	if mo.onkothhill then
		P_AddPlayerScore(p, 1) -- Increment by 1 each tic. 35 points per tic.
		
		if not (leveltime % 4)
			local r = mo.radius>>FRACBITS
			local h = mo.height>>FRACBITS
			local sparkle = P_SpawnMobj(mo.x + FixedMul(mo.scale, (P_RandomRange(r, -r)<<FRACBITS)),
										mo.y + FixedMul(mo.scale, (P_RandomRange(r, -r)<<FRACBITS)),
										mo.z + P_MobjFlip(mo)*FixedMul(mo.scale, (P_RandomKey(h)<<FRACBITS)),
										MT_NIGHTSPARKLE)
			if mo.eflags & MFE_VERTICALFLIP
				sparkle.momz = -FRACUNIT
			else
				sparkle.momz = FRACUNIT
			end
			P_SetMobjStateNF(sparkle, S_NIGHTSPARKLE2)
		end
	end
end)